zfsboottest.sh revision 267654
1#!/bin/sh
2#
3# Copyright (c) 2011 Pawel Jakub Dawidek <pawel@dawidek.net>
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10#    notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12#    notice, this list of conditions and the following disclaimer in the
13#    documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: releng/9.3/tools/tools/zfsboottest/zfsboottest.sh 254037 2013-08-07 07:32:56Z avg $
28
29if [ $# -ne 1 ]; then
30	echo "usage: zfsboottest.sh <pool>" >&2
31	exit 1
32fi
33
34which -s zfsboottest
35if [ $? -eq 0 ]; then
36	zfsboottest="zfsboottest"
37else
38	if [ ! -x "/usr/src/tools/tools/zfsboottest/zfsboottest" ]; then
39		echo "Unable to find \"zfsboottest\" utility." >&2
40		exit 1
41	fi
42	zfsboottest="/usr/src/tools/tools/zfsboottest/zfsboottest"
43fi
44
45startdir="/boot"
46
47pool="${1}"
48zpool list "${pool}" >/dev/null 2>&1
49if [ $? -ne 0 ]; then
50	echo "No such pool \"${pool}\"." >&2
51	exit 1
52fi
53bootfs=`zpool get bootfs "${pool}" | tail -1 | awk '{print $3}'`
54if [ "${bootfs}" = "-" ]; then
55	bootfs="${pool}"
56fi
57mountpoint=`df -t zfs "${bootfs}" 2>/dev/null | tail -1 | awk '{print $6}'`
58if [ -z "${mountpoint}" ]; then
59	echo "The \"${bootfs}\" dataset is not mounted." >&2
60	exit 1
61fi
62if [ ! -d "${mountpoint}${startdir}" ]; then
63	echo "The \"${mountpoint}${startdir}\" directory doesn't exist." >&2
64	exit 1
65fi
66vdevs=""
67for vdev in `zpool status "${pool}" | grep ONLINE | awk '{print $1}'`; do
68	vdev="/dev/${vdev#/dev/}"
69	if [ -c "${vdev}" ]; then
70		if [ -z "${vdevs}" ]; then
71			vdevs="${vdev}"
72		else
73			vdevs="${vdevs} ${vdev}"
74		fi
75	fi
76done
77
78list0=`mktemp /tmp/zfsboottest.XXXXXXXXXX`
79if [ $? -ne 0 ]; then
80	echo "Unable to create temporary file." >&2
81	exit 1
82fi
83list1=`mktemp /tmp/zfsboottest.XXXXXXXXXX`
84if [ $? -ne 0 ]; then
85	echo "Unable to create temporary file." >&2
86	rm -f "${list0}"
87	exit 1
88fi
89
90echo "zfsboottest.sh is reading all the files in ${mountpoint}${startdir} using"
91echo "boot code and using file system code."
92echo "It calculates MD5 checksums for all the files and will compare them."
93echo "If all files can be properly read using boot code, it is very likely you"
94echo "will be able to boot from \"${pool}\" pool>:> Good luck!"
95echo
96
97"${zfsboottest}" ${vdevs} - `find "${mountpoint}${startdir}" -type f | sed "s@^${mountpoint}@@"` | egrep '^[0-9a-z]{32} /' | sort -k 2 >"${list0}"
98find "${mountpoint}${startdir}" -type f | xargs md5 -r | sed "s@ ${mountpoint}@ @" | egrep '^[0-9a-z]{32} /' | sort -k 2 >"${list1}"
99
100diff -u "${list0}" "${list1}"
101ec=$?
102
103rm -f "${list0}" "${list1}"
104
105if [ $? -ne 0 ]; then
106	echo >&2
107	echo "You may not be able to boot." >&2
108	exit 1
109fi
110
111echo "OK"
112